/*******************************************************************************
 *  Copyright (c) 2012-2014 SAP SE.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *  SAP SE - initial API and implementation and/or initial documentation
 *
 *******************************************************************************/
/**
 */
package org.eclipse.ogee.model.edit.odata.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.ogee.model.odata.util.OdataAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class OdataItemProviderAdapterFactory extends OdataAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OdataItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EntityType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EntityTypeItemProvider entityTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EntityType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEntityTypeAdapter() {
		if (entityTypeItemProvider == null) {
			entityTypeItemProvider = new EntityTypeItemProvider(this);
		}

		return entityTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Property} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyItemProvider propertyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Property}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyAdapter() {
		if (propertyItemProvider == null) {
			propertyItemProvider = new PropertyItemProvider(this);
		}

		return propertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.ComplexType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComplexTypeItemProvider complexTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.ComplexType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createComplexTypeAdapter() {
		if (complexTypeItemProvider == null) {
			complexTypeItemProvider = new ComplexTypeItemProvider(this);
		}

		return complexTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Association} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AssociationItemProvider associationItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Association}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAssociationAdapter() {
		if (associationItemProvider == null) {
			associationItemProvider = new AssociationItemProvider(this);
		}

		return associationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.NavigationProperty} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NavigationPropertyItemProvider navigationPropertyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.NavigationProperty}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNavigationPropertyAdapter() {
		if (navigationPropertyItemProvider == null) {
			navigationPropertyItemProvider = new NavigationPropertyItemProvider(this);
		}

		return navigationPropertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.FunctionImport} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FunctionImportItemProvider functionImportItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.FunctionImport}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFunctionImportAdapter() {
		if (functionImportItemProvider == null) {
			functionImportItemProvider = new FunctionImportItemProvider(this);
		}

		return functionImportItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Parameter} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParameterItemProvider parameterItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Parameter}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createParameterAdapter() {
		if (parameterItemProvider == null) {
			parameterItemProvider = new ParameterItemProvider(this);
		}

		return parameterItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EntitySet} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EntitySetItemProvider entitySetItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EntitySet}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEntitySetAdapter() {
		if (entitySetItemProvider == null) {
			entitySetItemProvider = new EntitySetItemProvider(this);
		}

		return entitySetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.AssociationSet} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AssociationSetItemProvider associationSetItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.AssociationSet}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAssociationSetAdapter() {
		if (associationSetItemProvider == null) {
			associationSetItemProvider = new AssociationSetItemProvider(this);
		}

		return associationSetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Role} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RoleItemProvider roleItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Role}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRoleAdapter() {
		if (roleItemProvider == null) {
			roleItemProvider = new RoleItemProvider(this);
		}

		return roleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.AssociationSetEnd} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AssociationSetEndItemProvider associationSetEndItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.AssociationSetEnd}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAssociationSetEndAdapter() {
		if (associationSetEndItemProvider == null) {
			associationSetEndItemProvider = new AssociationSetEndItemProvider(this);
		}

		return associationSetEndItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EDMX} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EDMXItemProvider edmxItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EDMX}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEDMXAdapter() {
		if (edmxItemProvider == null) {
			edmxItemProvider = new EDMXItemProvider(this);
		}

		return edmxItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.ReferentialConstraint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReferentialConstraintItemProvider referentialConstraintItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.ReferentialConstraint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReferentialConstraintAdapter() {
		if (referentialConstraintItemProvider == null) {
			referentialConstraintItemProvider = new ReferentialConstraintItemProvider(this);
		}

		return referentialConstraintItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.SimpleType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SimpleTypeItemProvider simpleTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.SimpleType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSimpleTypeAdapter() {
		if (simpleTypeItemProvider == null) {
			simpleTypeItemProvider = new SimpleTypeItemProvider(this);
		}

		return simpleTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Binding} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BindingItemProvider bindingItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Binding}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBindingAdapter() {
		if (bindingItemProvider == null) {
			bindingItemProvider = new BindingItemProvider(this);
		}

		return bindingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.ValueTerm} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValueTermItemProvider valueTermItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.ValueTerm}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createValueTermAdapter() {
		if (valueTermItemProvider == null) {
			valueTermItemProvider = new ValueTermItemProvider(this);
		}

		return valueTermItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.ValueAnnotation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValueAnnotationItemProvider valueAnnotationItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.ValueAnnotation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createValueAnnotationAdapter() {
		if (valueAnnotationItemProvider == null) {
			valueAnnotationItemProvider = new ValueAnnotationItemProvider(this);
		}

		return valueAnnotationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.TypeAnnotation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TypeAnnotationItemProvider typeAnnotationItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.TypeAnnotation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTypeAnnotationAdapter() {
		if (typeAnnotationItemProvider == null) {
			typeAnnotationItemProvider = new TypeAnnotationItemProvider(this);
		}

		return typeAnnotationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EntityContainer} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EntityContainerItemProvider entityContainerItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EntityContainer}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEntityContainerAdapter() {
		if (entityContainerItemProvider == null) {
			entityContainerItemProvider = new EntityContainerItemProvider(this);
		}

		return entityContainerItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EnumType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumTypeItemProvider enumTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EnumType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEnumTypeAdapter() {
		if (enumTypeItemProvider == null) {
			enumTypeItemProvider = new EnumTypeItemProvider(this);
		}

		return enumTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EnumMember} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumMemberItemProvider enumMemberItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EnumMember}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEnumMemberAdapter() {
		if (enumMemberItemProvider == null) {
			enumMemberItemProvider = new EnumMemberItemProvider(this);
		}

		return enumMemberItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Documentation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentationItemProvider documentationItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Documentation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDocumentationAdapter() {
		if (documentationItemProvider == null) {
			documentationItemProvider = new DocumentationItemProvider(this);
		}

		return documentationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EDMXSet} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EDMXSetItemProvider edmxSetItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EDMXSet}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEDMXSetAdapter() {
		if (edmxSetItemProvider == null) {
			edmxSetItemProvider = new EDMXSetItemProvider(this);
		}

		return edmxSetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EntityTypeUsage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EntityTypeUsageItemProvider entityTypeUsageItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EntityTypeUsage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEntityTypeUsageAdapter() {
		if (entityTypeUsageItemProvider == null) {
			entityTypeUsageItemProvider = new EntityTypeUsageItemProvider(this);
		}

		return entityTypeUsageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.ComplexTypeUsage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComplexTypeUsageItemProvider complexTypeUsageItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.ComplexTypeUsage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createComplexTypeUsageAdapter() {
		if (complexTypeUsageItemProvider == null) {
			complexTypeUsageItemProvider = new ComplexTypeUsageItemProvider(this);
		}

		return complexTypeUsageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EnumTypeUsage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumTypeUsageItemProvider enumTypeUsageItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EnumTypeUsage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEnumTypeUsageAdapter() {
		if (enumTypeUsageItemProvider == null) {
			enumTypeUsageItemProvider = new EnumTypeUsageItemProvider(this);
		}

		return enumTypeUsageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.SimpleTypeUsage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SimpleTypeUsageItemProvider simpleTypeUsageItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.SimpleTypeUsage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSimpleTypeUsageAdapter() {
		if (simpleTypeUsageItemProvider == null) {
			simpleTypeUsageItemProvider = new SimpleTypeUsageItemProvider(this);
		}

		return simpleTypeUsageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EDMXReference} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EDMXReferenceItemProvider edmxReferenceItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EDMXReference}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEDMXReferenceAdapter() {
		if (edmxReferenceItemProvider == null) {
			edmxReferenceItemProvider = new EDMXReferenceItemProvider(this);
		}

		return edmxReferenceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EDMXAnnotationsReference} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EDMXAnnotationsReferenceItemProvider edmxAnnotationsReferenceItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EDMXAnnotationsReference}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEDMXAnnotationsReferenceAdapter() {
		if (edmxAnnotationsReferenceItemProvider == null) {
			edmxAnnotationsReferenceItemProvider = new EDMXAnnotationsReferenceItemProvider(this);
		}

		return edmxAnnotationsReferenceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Schema} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SchemaItemProvider schemaItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Schema}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSchemaAdapter() {
		if (schemaItemProvider == null) {
			schemaItemProvider = new SchemaItemProvider(this);
		}

		return schemaItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.DataService} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DataServiceItemProvider dataServiceItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.DataService}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDataServiceAdapter() {
		if (dataServiceItemProvider == null) {
			dataServiceItemProvider = new DataServiceItemProvider(this);
		}

		return dataServiceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.IncludeRestriction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IncludeRestrictionItemProvider includeRestrictionItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.IncludeRestriction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIncludeRestrictionAdapter() {
		if (includeRestrictionItemProvider == null) {
			includeRestrictionItemProvider = new IncludeRestrictionItemProvider(this);
		}

		return includeRestrictionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.PathValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PathValueItemProvider pathValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.PathValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPathValueAdapter() {
		if (pathValueItemProvider == null) {
			pathValueItemProvider = new PathValueItemProvider(this);
		}

		return pathValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Using} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UsingItemProvider usingItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Using}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUsingAdapter() {
		if (usingItemProvider == null) {
			usingItemProvider = new UsingItemProvider(this);
		}

		return usingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.RecordValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RecordValueItemProvider recordValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.RecordValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRecordValueAdapter() {
		if (recordValueItemProvider == null) {
			recordValueItemProvider = new RecordValueItemProvider(this);
		}

		return recordValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.ReturnEntityTypeUsage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReturnEntityTypeUsageItemProvider returnEntityTypeUsageItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.ReturnEntityTypeUsage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReturnEntityTypeUsageAdapter() {
		if (returnEntityTypeUsageItemProvider == null) {
			returnEntityTypeUsageItemProvider = new ReturnEntityTypeUsageItemProvider(this);
		}

		return returnEntityTypeUsageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link java.util.Map.Entry} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyMappingItemProvider propertyMappingItemProvider;

	/**
	 * This creates an adapter for a {@link java.util.Map.Entry}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyMappingAdapter() {
		if (propertyMappingItemProvider == null) {
			propertyMappingItemProvider = new PropertyMappingItemProvider(this);
		}

		return propertyMappingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.ValueCollection} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValueCollectionItemProvider valueCollectionItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.ValueCollection}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createValueCollectionAdapter() {
		if (valueCollectionItemProvider == null) {
			valueCollectionItemProvider = new ValueCollectionItemProvider(this);
		}

		return valueCollectionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link java.util.Map.Entry} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyToValueMapItemProvider propertyToValueMapItemProvider;

	/**
	 * This creates an adapter for a {@link java.util.Map.Entry}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyToValueMapAdapter() {
		if (propertyToValueMapItemProvider == null) {
			propertyToValueMapItemProvider = new PropertyToValueMapItemProvider(this);
		}

		return propertyToValueMapItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.BooleanValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BooleanValueItemProvider booleanValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.BooleanValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBooleanValueAdapter() {
		if (booleanValueItemProvider == null) {
			booleanValueItemProvider = new BooleanValueItemProvider(this);
		}

		return booleanValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.StringValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StringValueItemProvider stringValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.StringValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStringValueAdapter() {
		if (stringValueItemProvider == null) {
			stringValueItemProvider = new StringValueItemProvider(this);
		}

		return stringValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.BinaryValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BinaryValueItemProvider binaryValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.BinaryValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBinaryValueAdapter() {
		if (binaryValueItemProvider == null) {
			binaryValueItemProvider = new BinaryValueItemProvider(this);
		}

		return binaryValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.DateTimeValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DateTimeValueItemProvider dateTimeValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.DateTimeValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDateTimeValueAdapter() {
		if (dateTimeValueItemProvider == null) {
			dateTimeValueItemProvider = new DateTimeValueItemProvider(this);
		}

		return dateTimeValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.DecimalValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DecimalValueItemProvider decimalValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.DecimalValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDecimalValueAdapter() {
		if (decimalValueItemProvider == null) {
			decimalValueItemProvider = new DecimalValueItemProvider(this);
		}

		return decimalValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.GuidValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GuidValueItemProvider guidValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.GuidValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGuidValueAdapter() {
		if (guidValueItemProvider == null) {
			guidValueItemProvider = new GuidValueItemProvider(this);
		}

		return guidValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.TimeValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TimeValueItemProvider timeValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.TimeValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTimeValueAdapter() {
		if (timeValueItemProvider == null) {
			timeValueItemProvider = new TimeValueItemProvider(this);
		}

		return timeValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.SingleValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SingleValueItemProvider singleValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.SingleValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSingleValueAdapter() {
		if (singleValueItemProvider == null) {
			singleValueItemProvider = new SingleValueItemProvider(this);
		}

		return singleValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.DoubleValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DoubleValueItemProvider doubleValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.DoubleValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDoubleValueAdapter() {
		if (doubleValueItemProvider == null) {
			doubleValueItemProvider = new DoubleValueItemProvider(this);
		}

		return doubleValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.SByteValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SByteValueItemProvider sByteValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.SByteValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSByteValueAdapter() {
		if (sByteValueItemProvider == null) {
			sByteValueItemProvider = new SByteValueItemProvider(this);
		}

		return sByteValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Int16Value} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Int16ValueItemProvider int16ValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Int16Value}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInt16ValueAdapter() {
		if (int16ValueItemProvider == null) {
			int16ValueItemProvider = new Int16ValueItemProvider(this);
		}

		return int16ValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Int32Value} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Int32ValueItemProvider int32ValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Int32Value}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInt32ValueAdapter() {
		if (int32ValueItemProvider == null) {
			int32ValueItemProvider = new Int32ValueItemProvider(this);
		}

		return int32ValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.Int64Value} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Int64ValueItemProvider int64ValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.Int64Value}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInt64ValueAdapter() {
		if (int64ValueItemProvider == null) {
			int64ValueItemProvider = new Int64ValueItemProvider(this);
		}

		return int64ValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.DateTimeOffsetValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DateTimeOffsetValueItemProvider dateTimeOffsetValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.DateTimeOffsetValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDateTimeOffsetValueAdapter() {
		if (dateTimeOffsetValueItemProvider == null) {
			dateTimeOffsetValueItemProvider = new DateTimeOffsetValueItemProvider(this);
		}

		return dateTimeOffsetValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.ByteValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ByteValueItemProvider byteValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.ByteValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createByteValueAdapter() {
		if (byteValueItemProvider == null) {
			byteValueItemProvider = new ByteValueItemProvider(this);
		}

		return byteValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.ogee.model.odata.EnumValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EnumValueItemProvider enumValueItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.ogee.model.odata.EnumValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEnumValueAdapter() {
		if (enumValueItemProvider == null) {
			enumValueItemProvider = new EnumValueItemProvider(this);
		}

		return enumValueItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (entityTypeItemProvider != null) entityTypeItemProvider.dispose();
		if (propertyItemProvider != null) propertyItemProvider.dispose();
		if (complexTypeItemProvider != null) complexTypeItemProvider.dispose();
		if (associationItemProvider != null) associationItemProvider.dispose();
		if (navigationPropertyItemProvider != null) navigationPropertyItemProvider.dispose();
		if (functionImportItemProvider != null) functionImportItemProvider.dispose();
		if (parameterItemProvider != null) parameterItemProvider.dispose();
		if (entitySetItemProvider != null) entitySetItemProvider.dispose();
		if (associationSetItemProvider != null) associationSetItemProvider.dispose();
		if (roleItemProvider != null) roleItemProvider.dispose();
		if (associationSetEndItemProvider != null) associationSetEndItemProvider.dispose();
		if (edmxItemProvider != null) edmxItemProvider.dispose();
		if (referentialConstraintItemProvider != null) referentialConstraintItemProvider.dispose();
		if (simpleTypeItemProvider != null) simpleTypeItemProvider.dispose();
		if (bindingItemProvider != null) bindingItemProvider.dispose();
		if (valueTermItemProvider != null) valueTermItemProvider.dispose();
		if (valueAnnotationItemProvider != null) valueAnnotationItemProvider.dispose();
		if (typeAnnotationItemProvider != null) typeAnnotationItemProvider.dispose();
		if (entityContainerItemProvider != null) entityContainerItemProvider.dispose();
		if (enumTypeItemProvider != null) enumTypeItemProvider.dispose();
		if (enumMemberItemProvider != null) enumMemberItemProvider.dispose();
		if (documentationItemProvider != null) documentationItemProvider.dispose();
		if (edmxSetItemProvider != null) edmxSetItemProvider.dispose();
		if (entityTypeUsageItemProvider != null) entityTypeUsageItemProvider.dispose();
		if (complexTypeUsageItemProvider != null) complexTypeUsageItemProvider.dispose();
		if (enumTypeUsageItemProvider != null) enumTypeUsageItemProvider.dispose();
		if (simpleTypeUsageItemProvider != null) simpleTypeUsageItemProvider.dispose();
		if (edmxReferenceItemProvider != null) edmxReferenceItemProvider.dispose();
		if (edmxAnnotationsReferenceItemProvider != null) edmxAnnotationsReferenceItemProvider.dispose();
		if (schemaItemProvider != null) schemaItemProvider.dispose();
		if (dataServiceItemProvider != null) dataServiceItemProvider.dispose();
		if (includeRestrictionItemProvider != null) includeRestrictionItemProvider.dispose();
		if (pathValueItemProvider != null) pathValueItemProvider.dispose();
		if (usingItemProvider != null) usingItemProvider.dispose();
		if (recordValueItemProvider != null) recordValueItemProvider.dispose();
		if (returnEntityTypeUsageItemProvider != null) returnEntityTypeUsageItemProvider.dispose();
		if (propertyMappingItemProvider != null) propertyMappingItemProvider.dispose();
		if (valueCollectionItemProvider != null) valueCollectionItemProvider.dispose();
		if (propertyToValueMapItemProvider != null) propertyToValueMapItemProvider.dispose();
		if (booleanValueItemProvider != null) booleanValueItemProvider.dispose();
		if (stringValueItemProvider != null) stringValueItemProvider.dispose();
		if (binaryValueItemProvider != null) binaryValueItemProvider.dispose();
		if (dateTimeValueItemProvider != null) dateTimeValueItemProvider.dispose();
		if (decimalValueItemProvider != null) decimalValueItemProvider.dispose();
		if (guidValueItemProvider != null) guidValueItemProvider.dispose();
		if (timeValueItemProvider != null) timeValueItemProvider.dispose();
		if (singleValueItemProvider != null) singleValueItemProvider.dispose();
		if (doubleValueItemProvider != null) doubleValueItemProvider.dispose();
		if (sByteValueItemProvider != null) sByteValueItemProvider.dispose();
		if (int16ValueItemProvider != null) int16ValueItemProvider.dispose();
		if (int32ValueItemProvider != null) int32ValueItemProvider.dispose();
		if (int64ValueItemProvider != null) int64ValueItemProvider.dispose();
		if (dateTimeOffsetValueItemProvider != null) dateTimeOffsetValueItemProvider.dispose();
		if (byteValueItemProvider != null) byteValueItemProvider.dispose();
		if (enumValueItemProvider != null) enumValueItemProvider.dispose();
	}

}
